package io.openraven.services;

import io.openraven.services.google.GoogleWorkspaceSettingsService;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.context.annotation.Profile;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;
import java.util.UUID;

@Service
@Order(EnsureDefaultSettingsApplicationRunner.ORDER)
@Profile("gcp")
public class EnsureDefaultSettingsApplicationRunner implements ApplicationRunner {
    public static final int ORDER = 12;
    protected static final List<UUID> DEFAULT_DATA_COLLECTIONS = List.of(
            UUID.fromString("dc86abd1-0857-4957-b59f-6f7ab2ebef5e"),
            UUID.fromString("48e35706-b2f8-4c6b-b3ce-36e61f10b441"),
            UUID.fromString("0c949d94-00ae-4d24-8306-0d866b644514"),
            UUID.fromString("19ee3975-79a6-453b-96f4-f75899c6cdb9"),
            UUID.fromString("77c64da5-4249-4981-8ffa-08d66c45b68f"),
            UUID.fromString("7e2a312f-d71c-4d5e-bdf7-15caac333d8d"),
            UUID.fromString("850679d2-b903-4668-ad54-f84aabac14c2")
    );

    protected static final String DEFAULT_QUARANTINE_TEXT =
            "This folder is automatically generated by Open Raven to store files whose sharing permissions were altered or revoked, either manually or automatically. Originally located in a different folder on the same drive, these files were moved here due to their former folder's inappropriate sharing settings, which risked exposing sensitive data. This relocation ensures they are no longer accessible to prior collaborators.\n" +
                    "\n" +
                    "In the original folder, shortcuts to these files have been created. While visible to former collaborators, these shortcuts do not grant access to the file contents. If moved back to their original location, access will be reinstated.\n" +
                    "\n" +
                    "If you think a file has been mistakenly moved to this folder, please reach out to your Google Administrator.\n";
    protected static final String DEFAULT_AWS_REGION = "us-west-2";
    protected static final String DEFAULT_GCP_REGION = "us-west1";
    protected static final long DEFAULT_SCAN_BUDGET = 10;

    private final GlobalConfigurationService globalConfigurationService;

    public EnsureDefaultSettingsApplicationRunner(GlobalConfigurationService globalConfigurationService) {
        this.globalConfigurationService = globalConfigurationService;
    }

    @Override
    public void run(ApplicationArguments args) {
        globalConfigurationService.writeTextValueIfAbsent(GoogleWorkspaceSettingsService.AWS_REGION,
                DEFAULT_AWS_REGION);
        globalConfigurationService.writeTextValueIfAbsent(GoogleWorkspaceSettingsService.GCP_REGION,
                DEFAULT_GCP_REGION);
        globalConfigurationService.writeLongValueIfAbsent(GoogleWorkspaceSettingsService.SCAN_BUDGET,
                DEFAULT_SCAN_BUDGET);
        globalConfigurationService.writeListValueIfAbsent(GoogleWorkspaceSettingsService.AUTO_SCAN_DATA_COLLECTIONS,
                DEFAULT_DATA_COLLECTIONS);
        globalConfigurationService.writeTextValueIfAbsent(GoogleWorkspaceSettingsService.QUARANTINE_TEXT,
                DEFAULT_QUARANTINE_TEXT);
        globalConfigurationService.writeListValueIfAbsent(GoogleWorkspaceSettingsService.ALLOWED_DOMAINS,
                Collections.emptyList());
        globalConfigurationService.writeListValueIfAbsent(GoogleWorkspaceSettingsService.DENIED_DOMAINS,
                Collections.emptyList());
    }

}